unit Unit_ExemplePartie8;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ShellAPI; //Ne pas oublier ShellAPI

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    OpenDialog1: TOpenDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
if OpenDialog1.Execute then
  Edit1.Text:=OpenDialog1.FileName;
end;

procedure ErrorDlg(const Msg:String);
begin
MessageDlg(Msg,mtError,[mbOk],0);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
//Ne pas oublier PChar()
case ShellExecute(Handle,'Open',PChar(Edit1.Text),nil,nil,SW_SHOWDEFAULT) of
  0: ErrorDlg('Le systme n''a plus de mmoire disponible pour excuter cette action.');
  ERROR_FILE_NOT_FOUND: ErrorDlg('Le fichier spcifi est introuvable.');
  ERROR_PATH_NOT_FOUND: ErrorDlg('Le dossier spcifi est introuvable.');
  ERROR_BAD_FORMAT: ErrorDlg('L''excutable spcifi n''est pas un excutable Win32 valide.');
  SE_ERR_ACCESSDENIED: ErrorDlg('Impossible d''atteindre le fichier spcifi : accs refus.');
  SE_ERR_OOM: ErrorDlg('Le systme n''a plus assez de mmoire disponible pour terminer cette opration.');
  SE_ERR_SHARE: ErrorDlg('Le fichier spcifi n''a pas de programme associ.');
  end;
end;

end.
